<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarBookingRulesOption ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarBookingRulesOption extends AbstractStructArrayBase
{
    /**
     * The RentacarOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarBookingRulesOption[]
     */
    public $RentacarOption;
    /**
     * Constructor method for ArrayOfJP_RentacarBookingRulesOption
     * @uses ArrayOfJP_RentacarBookingRulesOption::setRentacarOption()
     * @param \StructType\JP_RentacarBookingRulesOption[] $rentacarOption
     */
    public function __construct(array $rentacarOption = array())
    {
        $this
            ->setRentacarOption($rentacarOption);
    }
    /**
     * Get RentacarOption value
     * @return \StructType\JP_RentacarBookingRulesOption[]|null
     */
    public function getRentacarOption()
    {
        return $this->RentacarOption;
    }
    /**
     * Set RentacarOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarBookingRulesOption[] $rentacarOption
     * @return \ArrayType\ArrayOfJP_RentacarBookingRulesOption
     */
    public function setRentacarOption(array $rentacarOption = array())
    {
        foreach ($rentacarOption as $arrayOfJP_RentacarBookingRulesOptionRentacarOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarBookingRulesOptionRentacarOptionItem instanceof \StructType\JP_RentacarBookingRulesOption) {
                throw new \InvalidArgumentException(sprintf('The RentacarOption property can only contain items of \StructType\JP_RentacarBookingRulesOption, "%s" given', is_object($arrayOfJP_RentacarBookingRulesOptionRentacarOptionItem) ? get_class($arrayOfJP_RentacarBookingRulesOptionRentacarOptionItem) : gettype($arrayOfJP_RentacarBookingRulesOptionRentacarOptionItem)), __LINE__);
            }
        }
        $this->RentacarOption = $rentacarOption;
        return $this;
    }
    /**
     * Add item to RentacarOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarBookingRulesOption $item
     * @return \ArrayType\ArrayOfJP_RentacarBookingRulesOption
     */
    public function addToRentacarOption(\StructType\JP_RentacarBookingRulesOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarBookingRulesOption) {
            throw new \InvalidArgumentException(sprintf('The RentacarOption property can only contain items of \StructType\JP_RentacarBookingRulesOption, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RentacarOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarBookingRulesOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarBookingRulesOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarBookingRulesOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarBookingRulesOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarBookingRulesOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarOption
     */
    public function getAttributeName()
    {
        return 'RentacarOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RentacarBookingRulesOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
